/*
Bypass
Copyright (C) 1999-2001 Douglas Thain
http://www.cs.wisc.edu/condor/bypass
This program is released under the GNU General Public License.
See the file COPYING for details.
*/

#ifndef LAYER_H
#define LAYER_H

#ifdef __cplusplus
extern "C" {
#endif

/*
These functions are provided by the layer object
for tracking the state of the process and its layers.
*/

int   layer_register( char *library_name, int is_agent);
void* layer_lookup( char *name, char *standard_name, int key );
int   layer_is_agent();
void  layer_descend();
void  layer_ascend();
void  layer_top();
void  layer_bottom();

void  layer_fatal( char *str, ... );
void  layer_dump();
void  layer_debug( char *str );

struct layer_entry * layer_get();
void                 layer_set( struct layer_entry *layer );

/*
These functions are not provided by the layer object,
but must be defined elsewhere in the program.
They provide the threading tools, depending on whether
the user really wants thread-safe code.
*/

void layer_pthread_mutex_lock();
void layer_pthread_mutex_unlock();
int  layer_pthread_self();

#ifdef __cplusplus
}
#endif

#endif
